package teetime.stage.io;

import java.io.File;
import java.io.IOException;

import teetime.framework.AbstractConsumerStage;
import teetime.framework.OutputPort;
import teetime.framework.IStage;

import com.google.common.io.Files;

public class File2ByteArray extends AbstractConsumerStage<File> implements IStage {

	private final OutputPort<byte[]> outputPort = this.createOutputPort();

	@Override
	protected void execute(final File element) {
		try {
			byte[] cache = Files.toByteArray(element);
			this.send(this.outputPort, cache);
		} catch (IOException e) {
			throw new IllegalStateException(e);
		}
	}

	public OutputPort<? extends byte[]> getOutputPort() {
		return this.outputPort;
	}

	@Override
	public boolean shouldBeTerminated() {
		return false;
	}

	@Override
	public void terminate() {

	}
}
